Raphael.fn.drawGrid = function (x, y, w, h, wv, hv, color) {
    color = color || DirectMail.systemAppearance["color-grid"];
    var path = ["M", Math.round(x) + .5, Math.round(y) + .5, "L", Math.round(x + w) + .5, Math.round(y) + .5, Math.round(x + w) + .5, Math.round(y + h) + .5, Math.round(x) + .5, Math.round(y + h) + .5, Math.round(x) + .5, Math.round(y) + .5],
    rowHeight = h / hv,
    columnWidth = w / wv;
    for (var i = 1; i < hv; i++) {
        path = path.concat(["M", Math.round(x) + .5, Math.round(y + i * rowHeight) + .5, "H", Math.round(x + w) + .5]);
    }
    for (i = 1; i < wv; i++) {
        path = path.concat(["M", Math.round(x + i * columnWidth) + .5, Math.round(y) + .5, "V", Math.round(y + h) + .5]);
    }
    return this.path(path.join(",")).attr({stroke: color});
};

Raphael.fn.makeMasterLabelTextElement = function(masterLabel, txt) {
    return this.text(0, 0, masterLabel.label + (masterLabel.sublabel ? "\n" + masterLabel.sublabel : "")).attr(txt);
};

Raphael.fn.printing = function() {
    return window.document.getElementsByTagName("html").item(0).getAttribute("data-media") == "print";
};

Raphael.fn.labelFont = function(size, colorname) {
    return this.printing()
    ? {font: '9px Helvetica, sans-serif', fill: 'black'}
    : {'font-family': '-apple-system, "Helvetica Neue", Helvetica, sans-serif', 'font-size': size || '12px', fill: DirectMail.systemAppearance[colorname || 'color-label']};
};

Raphael.fn.sublabelFont = function() {
    return this.printing()
    ? {font: '7.5px Helvetica, sans-serif', fill: 'black'}
    : {font: '10px -apple-system, "Helvetica Neue", Helvetica, sans-serif', fill: DirectMail.systemAppearance['color-label']};
};
