use 5.006;
use strict;
use warnings;
package Email::MIME;
use Email::Simple 2.004;
use base qw(Email::Simple);
use Carp ();
use Email::MessageID;
use Email::MIME::Creator;
use Email::MIME::ContentType;
use Email::MIME::Encodings 1.313;
use Email::MIME::Header;
use Email::MIME::Modifier;
use Encode ();
our$VERSION='1.903';
use vars qw[$CREATOR];
$CREATOR='Email::MIME::Creator';
sub new{my$self=shift->SUPER::new(@_);
$self->{ct}=parse_content_type($self->content_type);
$self->parts;
return$self;}sub create{my($class,%args)=@_;
my$header='';
my%headers;
if(exists$args{header}){my@headers=@{$args{header}};
pop@headers if@headers%2==1;
while(my($key,$value)=splice@headers,0,2){$headers{$key}=1;
$CREATOR->_add_to_header(\$header,$key,$value);}}if(exists$args{header_str}){my@headers=@{$args{header_str}};
pop@headers if@headers%2==1;
while(my($key,$value)=splice@headers,0,2){$headers{$key}=1;
$value=Encode::encode('MIME-Q',$value,1);
$CREATOR->_add_to_header(\$header,$key,$value);}}$CREATOR->_add_to_header(\$header,Date=>$CREATOR->_date_header)unless exists$headers{Date};
$CREATOR->_add_to_header(\$header,'MIME-Version'=>'1.0',);
my%attrs=$args{attributes}?%{$args{attributes}}:();
if(grep{exists$attrs{$_}}qw(content_type charset name format boundary)){$CREATOR->_add_to_header(\$header,'Content-Type'=>'text/plain',);}my$email=$class->new($header);
foreach(qw(
content_type charset name format boundary
encoding
disposition filename
)){my$set="$_\_set";
$email->$set($attrs{$_})if exists$attrs{$_};}my$body_args=grep{defined$args{$_}}qw(parts body body_str);
Carp::confess("only one of parts, body, or body_str may be given")if$body_args>1;
if($args{parts}&&@{$args{parts}}){foreach my $part(@{$args{parts}}){$part=$CREATOR->_construct_part($part)unless ref($part);}$email->parts_set($args{parts});}elsif(defined$args{body}){$email->body_set($args{body});}elsif(defined$args{body_str}){Carp::confess("body_str was given, but no charset is defined")unless my$charset=$attrs{charset};
Carp::confess("body_str was given, but no encoding is defined")unless$attrs{encoding};
my$body_octets=Encode::encode($attrs{charset},$args{body_str},1);
$email->body_set($body_octets);}$email;}sub as_string{my$self=shift;
return$self->__head->as_string.($self->{mycrlf}||"\n").$self->body_raw;}sub parts{my$self=shift;
$self->fill_parts unless$self->{parts};
my@parts=@{$self->{parts}};
@parts=$self unless@parts;
return@parts;}sub subparts{my($self)=@_;
$self->fill_parts unless$self->{parts};
my@parts=@{$self->{parts}};
return@parts;}sub fill_parts{my$self=shift;
if($self->{ct}{discrete}eq"multipart" or$self->{ct}{discrete}eq"message"){$self->parts_multipart;}else{$self->parts_single_part;}return$self;}sub body{my$self=shift;
my$body=$self->SUPER::body;
my$cte=$self->header("Content-Transfer-Encoding")||'';
$cte=~s/\A\s+//;
$cte=~s/\s+\z//;
$cte=~s/;.+//;
return$body unless$cte;
if(!$self->force_decode_hook and$cte=~/\A(?:7bit|8bit|binary)\z/i){return$body;}$body=$self->decode_hook($body)if$self->can("decode_hook");
$body=Email::MIME::Encodings::decode($cte,$body);
return$body;}sub parts_single_part{my$self=shift;
$self->{parts}=[];
return$self;}sub body_raw{return$_[0]->{body_raw}||$_[0]->SUPER::body;}sub body_str{my($self)=@_;
my$encoding=$self->{ct}{attributes}{charset};
unless($encoding){if($self->{ct}{discrete}eq 'text' and($self->{ct}{composite}eq 'plain' or$self->{ct}{composite}eq 'html')){return$self->body;}Carp::confess("can't get body as a string for ".$self->content_type);}my$str=Encode::decode($encoding,$self->body,1);
return$str;}sub parts_multipart{my$self=shift;
my$boundary=$self->{ct}->{attributes}->{boundary};
return$self->parts_single_part unless$boundary and$self->body_raw=~/^--\Q$boundary\E\s*$/sm;
$self->{body_raw}=$self->SUPER::body;
my($body,$epilogue)=split/^--\Q$boundary\E--\s*$/sm,$self->body_raw,2;
my@bits=split/^--\Q$boundary\E\s*$/sm,($body||'');
$self->SUPER::body_set(undef);
$self->SUPER::body_set(shift@bits)if($bits[0]||'')!~/.*:.*/;
my$bits=@bits;
my@parts;
for my $bit(@bits){$bit=~s/\A[\n\r]+//smg;
my$email=(ref$self)->new($bit);
push@parts,$email;}$self->{parts}=\@parts;
return@{$self->{parts}};}sub force_decode_hook{0}sub decode_hook{return$_[1]}sub content_type{scalar shift->header("Content-type");}sub debug_structure{my($self,$level)=@_;
$level||=0;
my$rv=" " x(5*$level);
$rv.="+ ".$self->content_type."\n";
my@parts=$self->parts;
if(@parts>1){$rv.=$_->debug_structure($level+1)for@parts;}return$rv;}my%gcache;
sub filename{my($self,$force)=@_;
return$gcache{$self}if exists$gcache{$self};
my$dis=$self->header("Content-Disposition")||'';
my$attrs=$dis=~s/^.*?;//?Email::MIME::ContentType::_parse_attributes($dis):{};
my$name=$attrs->{filename}||$self->{ct}{attributes}{name};
return$name if$name or!$force;
return$gcache{$self}=$self->invent_filename($self->{ct}->{discrete}."/".$self->{ct}->{composite});}my$gname=0;
sub invent_filename{my($self,$ct)=@_;
require MIME::Types;
my$type=MIME::Types->new->type($ct);
my$ext=$type&&(($type->extensions)[0]);
$ext||="dat";
return"attachment-$$-".$gname++ .".$ext";}sub default_header_class{'Email::MIME::Header'}sub header_str_set{my$self=shift;
$self->header_obj->header_str_set(@_);}sub content_type_set{my($self,$ct)=@_;
my$ct_header=parse_content_type($self->header('Content-Type'));
@{$ct_header}{qw[discrete composite]}=split m[/],$ct;
$self->_compose_content_type($ct_header);
$self->_reset_cids;
return$ct;}BEGIN{foreach my $attr(qw[charset name format]){my$code=sub{my($self,$value)=@_;
my$ct_header=parse_content_type($self->header('Content-Type'));
if($value){$ct_header->{attributes}->{$attr}=$value;}else{delete$ct_header->{attributes}->{$attr};}$self->_compose_content_type($ct_header);
return$value;};
no strict 'refs';
*{"$attr\_set"}=$code;}}sub boundary_set{my($self,$value)=@_;
my$ct_header=parse_content_type($self->header('Content-Type'));
if($value){$ct_header->{attributes}->{boundary}=$value;}else{delete$ct_header->{attributes}->{boundary};}$self->_compose_content_type($ct_header);
$self->parts_set([$self->parts])if$self->parts>1;}sub encoding_set{my($self,$enc)=@_;
$enc||='7bit';
my$body=$self->body;
$self->header_set('Content-Transfer-Encoding'=>$enc);
$self->body_set($body);}sub body_set{my($self,$body)=@_;
my$body_ref;
if(ref$body){$body_ref=$body;
$body=$$body_ref;}else{$body_ref=\$body;}my$enc=$self->header('Content-Transfer-Encoding');
unless(((caller(1))[3]||'')eq 'Email::Simple::new'){$body=Email::MIME::Encodings::encode($enc,$body)unless!$enc||$enc=~/^(?:7bit|8bit|binary)\s*$/i;}$self->{body_raw}=$body;
$self->SUPER::body_set($body_ref);}sub body_str_set{my($self,$body_str)=@_;
my$ct=parse_content_type($self->content_type);
Carp::confess("body_str was given, but no charset is defined")unless my$charset=$ct->{attributes}{charset};
my$body_octets=Encode::encode($charset,$body_str,1);
$self->body_set($body_octets);}sub disposition_set{my($self,$dis)=@_;
$dis||='inline';
my$dis_header=$self->header('Content-Disposition');
$dis_header?($dis_header=~s/^([^;]+)/$dis/):($dis_header=$dis);
$self->header_set('Content-Disposition'=>$dis_header);}sub filename_set{my($self,$filename)=@_;
my$dis_header=$self->header('Content-Disposition');
my($disposition,$attrs);
if($dis_header){($disposition)=($dis_header=~/^([^;]+)/);
$dis_header=~s/^$disposition(?:;\s*)?//;
$attrs=Email::MIME::ContentType::_parse_attributes($dis_header)||{};}$filename?$attrs->{filename}=$filename:delete$attrs->{filename};
$disposition||='inline';
my$dis=$disposition;
while(my($attr,$val)=each%{$attrs}){$dis.=qq[; $attr="$val"];}$self->header_set('Content-Disposition'=>$dis);}sub parts_set{my($self,$parts)=@_;
my$body=q{};
my$ct_header=parse_content_type($self->header('Content-Type'));
if(@{$parts}>1 or$ct_header->{discrete}eq 'multipart'){$ct_header->{attributes}->{boundary}||=Email::MessageID->new->user;
my$bound=$ct_header->{attributes}->{boundary};
foreach my $part(@{$parts}){$body.="$self->{mycrlf}--$bound$self->{mycrlf}";
$body.=$part->as_string;}$body.="$self->{mycrlf}--$bound--$self->{mycrlf}";
@{$ct_header}{qw[discrete composite]}=qw[multipart mixed]unless grep{$ct_header->{discrete}eq$_}qw[multipart message];}elsif(@$parts==1){$body.=$parts->[0]->body;
@{$ct_header}{qw[discrete composite]}=@{parse_content_type($parts->[0]->header('Content-Type'))}{qw[discrete composite]};
$self->encoding_set($parts->[0]->header('Content-Transfer-Encoding'));
delete$ct_header->{attributes}->{boundary};}$self->_compose_content_type($ct_header);
$self->body_set($body);
$self->fill_parts;
$self->_reset_cids;}sub parts_add{my($self,$parts)=@_;
$self->parts_set([$self->parts,@{$parts},]);}sub walk_parts{my($self,$callback)=@_;
my$walk;
$walk=sub{my($part)=@_;
$callback->($part);
if($part->parts>1){my@subparts;
for($part->parts){push@subparts,$walk->($_);}$part->parts_set(\@subparts);}return$part;};
$walk->($self);}sub _compose_content_type{my($self,$ct_header)=@_;
my$ct=join q{/},@{$ct_header}{qw[discrete composite]};
for my $attr(sort keys%{$ct_header->{attributes}}){$ct.=qq[; $attr="$ct_header->{attributes}{$attr}"];}$self->header_set('Content-Type'=>$ct);
$self->{ct}=$ct_header;}sub _get_cid{Email::MessageID->new->address;}sub _reset_cids{my($self)=@_;
my$ct_header=parse_content_type($self->header('Content-Type'));
if($self->parts>1){if($ct_header->{composite}eq 'alternative'){my%cids;
for my $part($self->parts){my$cid=defined$part->header('Content-ID')?$part->header('Content-ID'):q{};
$cids{$cid}++;}return if keys(%cids)==1;
my$cid=$self->_get_cid;
$_->header_set('Content-ID'=>"<$cid>")for$self->parts;}else{foreach($self->parts){my$cid=$self->_get_cid;
$_->header_set('Content-ID'=>"<$cid>")unless$_->header('Content-ID');}}}}1;
__END__


