package Email::MIME::ContentType;
use base 'Exporter';
use vars qw[
  $VERSION @EXPORT
  $STRICT_PARAMS
];
@EXPORT=qw(parse_content_type);
use strict;
use Carp;
$VERSION='1.015';
$STRICT_PARAMS=1;
my$tspecials=quotemeta '()<>@,;:\\"/[]?=';
my$ct_default='text/plain; charset=us-ascii';
my$extract_quoted=qr/(?:\"(?:[^\\\"]*(?:\\.[^\\\"]*)*)\"|\'(?:[^\\\']*(?:\\.[^\\\']*)*)\')/;
{my$discrete=qr/[^$tspecials]+/;
my$composite=qr/[^$tspecials]+/;
my$params=qr/;.*/;
sub parse_content_type{my$ct=shift;
return parse_content_type($ct_default)unless defined$ct and length$ct;
return parse_content_type($ct_default)unless$ct=~m[ ^ ($discrete) / ($composite) \s* ($params)? $ ]x;
return{discrete=>lc$1,composite=>lc$2,attributes=>_parse_attributes($3)};}}sub _parse_attributes{local$_=shift;
my$attribs={};
while($_){s/^;//;
s/^\s+// and next;
s/\s+$//;
unless(s/^([^$tspecials]+)=//){carp"Illegal Content-Type parameter $_" if$STRICT_PARAMS or$_;
return$attribs;}my$attribute=lc$1;
my$value=_extract_ct_attribute_value();
$attribs->{$attribute}=$value;}return$attribs;}sub _extract_ct_attribute_value{my$value;
while($_){s/^([^$tspecials]+)// and$value.=$1;
s/^($extract_quoted)// and do{my$sub=$1;$sub=~s/^["']//;$sub=~s/["']$//;
$value.=$sub;};
/^;/ and last;
/^([$tspecials])/ and do{carp"Unquoted $1 not allowed in Content-Type!";
return;}}return$value;}1;
__END__

